use anyhow::Result;
use serde::{Deserialize, Serialize};
use std::io::Read;
use toml;

use crate::api;

#[derive(Debug, Clone, PartialEq, Eq, Serialize, Deserialize, Default)]
pub struct Config {
    pub keys: String,
    pub api: api::Config,
    // db: db::Config,
}

impl Config {
    pub fn read(fp: &str) -> Result<Self> {
        let mut file = std::fs::File::open(fp)?;
        let mut contents = String::new();
        file.read_to_string(&mut contents)?;
        let c: Config = toml::from_str(&contents)?;
        Ok(c)
    }

    pub fn to_string(&self) -> Result<String> {
        let x = toml::to_string(&self)?;
        Ok(x)
    }
}
